/**
 *  Copyright 2012 Martynas Jusevičius <martynas@graphity.org>
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

package org.graphity.util;

import com.hp.hpl.jena.query.QuerySolution;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.rdf.model.RDFNode;
import java.util.Iterator;

/**
 *
 * @author Martynas Jusevičius <martynas@graphity.org>
 */
public class ResultSetUtils
{
    public static long hashResultSet(ResultSet result)
    {
    	long hash = 0;
	
	while (result.hasNext()) hash ^= hashQuerySolution(result.next());
	
	return hash;
    }
    
    public static long hashQuerySolution(QuerySolution solution)
    {
	long hash = 0;
	
	Iterator<String> it = solution.varNames();
	while (it.hasNext())
	{
	    RDFNode node = solution.get(it.next());
	    if (node != null) hash ^= (long) node.hashCode();
	}
	
	return hash;
    }
    
}